
#include "mammut.h"

static GtkWidget *drawing_area;
static GtkWidget *progressbar;
static GdkPixmap *pixmap;
GdkGC *blueGC;
GdkColor bluecolor;

void GUI_progressbar(int minvalue,int newvalue,int maxvalue){
  static int last=0;
  static int lastpercent=0;
  int percent;

  if(newvalue==last) return;


  percent=(int)(100.0f*(float)(newvalue-minvalue))/(float)(maxvalue-minvalue);
  if(percent==lastpercent) return;

  last=newvalue;
  lastpercent=percent;

#if 0
  printf("progress: %0.1f/100.0\n",percent);
#else
  gtk_progress_bar_update(GTK_PROGRESS_BAR(progressbar),(float)percent/100.0f);

  while(gtk_events_pending()>0)
    gtk_main_iteration_do(FALSE);
#endif
}

void drawscale()
{
  int i, grafx, ch;
  char tall[10];

  GdkGC *gc=blueGC;
    //drawing_area->style->black_gc;
  GdkFont *font=drawing_area->style->font;

  /*
  theGC=theGCblue; showGC=showGCblue;
  XDrawLine(theDisplay,bitmap,theGC,40,theheight+20,850,theheight+20);
  XDrawLine(theDisplay,bitmap,theGC,40,theheight+20,40,10);


  void gdk_draw_line	 (GdkDrawable  *drawable,
			  GdkGC	       *gc,
			  gint		x1,
			  gint		y1,
			  gint		x2,
			  gint		y2);
  */
  gdk_draw_line(
		pixmap,
		drawing_area->style->black_gc,
		40,theheight+20,
		850,theheight+20
		);
  gdk_draw_line(
		pixmap,
		drawing_area->style->black_gc,
		40,theheight+20,
		40,10
		);

  /*
void gdk_draw_string	 (GdkDrawable  *drawable,
			  GdkFont      *font,
			  GdkGC	       *gc,
			  gint		x,
			  gint		y,
			  const gchar  *string);
  */

  for (i=0; i<=(int)(R/2000.); i++) {
    grafx=(int)(i*1600000./R)+50;
    gdk_draw_line(pixmap,gc,grafx,theheight+15,grafx,theheight+25);
    if (zoom) {
      if ((i%2==0) && (i>0) && (i<22)) {
        sprintf(tall, "%d", i*100+leftkc*1000);
        gdk_draw_string(pixmap,font,gc,
          grafx-14,theheight+40,tall);
      }
    } else {
      sprintf(tall, "%d", i);
      gdk_draw_string(pixmap,font,gc,
        grafx-6,theheight+40,tall);
    }
  }

  for (ch=0; ch<samps_per_frame; ch++) {
    for (i=0; i<=10; i++) {
      grafx=(ch+1)*theheight/samps_per_frame-i*35./samps_per_frame+10;
      gdk_draw_line(pixmap,gc,35,grafx,45,grafx);
      sprintf(tall, "%2d", i);
      gdk_draw_string(pixmap,font,gc, 4,grafx+5,tall);
    }
  }


  /*
    for (i=0; i<=10; i++) {
    grafx=theheight-i*(samps_per_frame==1?35:17.5)+10;
    gdk_draw_line(pixmap,gc,35,grafx,45,grafx);
    sprintf(tall, "%2d", i);
    gdk_draw_string(pixmap,font,gc,
    4,grafx+5,tall);
    }
    if (samps_per_frame==2) for (i=0; i<=10; i++) {
    grafx=theheight/2-i*17.5+10;
    gdk_draw_line(pixmap,gc,35,grafx,45,grafx);
    sprintf(tall, "%2d", i);
    gdk_draw_string(pixmap,font,gc,
    4,grafx+5,tall);
    }
  */
}



void RestoreWin(int x1,int y1,int width,int height){
  /*
  XCopyArea(theDisplay, bitmap, XtWindow(sketchpad),
    DefaultGCOfScreen(XtScreen(sketchpad)), 0, 0, 800+70, theheight+70, 0, 0);
  */

  gdk_draw_pixmap(drawing_area->window,
		  drawing_area->style->fg_gc[GTK_WIDGET_STATE (drawing_area)],
		  pixmap,
		  x1,y1,
		  x1,y1,
		  width,height
		  );
}

void RestoreWinAll(void){
  RestoreWin(0,0,drawing_area->allocation.width,drawing_area->allocation.height);
}


void RedrawWin(void)
{
  long i;
  //  XSegment list0[LSIZE];
  GdkSegment list0[LSIZE];
  int c0=0, y, grafx, grafold=-1, start, range,ch;
  double real, imag, amp, maxamp=-1.;
  GdkGC *gc=drawing_area->style->black_gc;

  gdk_draw_rectangle (pixmap,
		      drawing_area->style->white_gc,
		      TRUE,
		      0, 0,
		      drawing_area->allocation.width,
		      drawing_area->allocation.height);

  gdk_draw_rectangle (drawing_area->window,
		      drawing_area->style->white_gc,
		      TRUE,
		      0, 0,
		      drawing_area->allocation.width,
		      drawing_area->allocation.height);

  drawscale();

  RestoreWinAll();

  start=(zoom==0?0:1000.*leftkc*N/R);
  range=N/(zoom?20:2); if (start+range>=N/2) range=N/2-start-1;

  for (ch=0; ch<samps_per_frame; ch++) {
    for (i=0; i<range; i++) {
      grafx = (int)(i*800./(N/(zoom?20.:2.)))+50;
      real=lyd[(i+start)*2+ch*N]; imag=lyd[(i+start)*2+1+ch*N];
      amp=sqrt(real*real+imag*imag)*N;
      if (amp>maxamp) maxamp=amp;
      if (grafx!=grafold) {
        maxamp/=samps_per_frame;
        y = (ch+1)*theheight/samps_per_frame-(int)(maxamp/10.)+10;
        ADD_LINE(grafx,(ch+1)*theheight/samps_per_frame+10,grafx,y,list0,c0,
          gc,gc);
        grafold=grafx;
        maxamp=-1.;
      }
    }
    FLUSH_LIST(list0,c0,gc,gc);
    RestoreWinAll();
  }

  /*
  for (i=0; i<range; i++) {
    grafx = (int)(i*800./(N/(zoom?20.:2.)))+50;
    real=lyd[(i+start)*2]; imag=lyd[(i+start)*2+1];
    amp=sqrt(real*real+imag*imag)*N;
    if (amp>maxamp) maxamp=amp;
    if (grafx!=grafold) {
      if (samps_per_frame==2) maxamp*=0.5;
      y = theheight-(int)(maxamp/10.)+10;
      ADD_LINE(grafx,theheight+10,grafx,y,list0,c0,gc,gc);
      grafold=grafx;
      maxamp=-1.;
    }
  }
  FLUSH_LIST(list0,c0,gc,gc);
  RestoreWinAll();

  if (samps_per_frame==2) {
    for (i=0; i<range; i++) {
      grafx = (int)(i*800./(N/(zoom?20.:2.)))+50;
      real=lyd[(i+start)*2]; imag=lyd[(i+start)*2+1];
      amp=sqrt(real*real+imag*imag)*N;
      if (amp>maxamp) maxamp=amp;
      if (grafx!=grafold) {
        y = theheight/2-(int)(maxamp/20.)+10;
        ADD_LINE(grafx,theheight/2+10,grafx,y,list0,c0,gc,gc);
        grafold=grafx;
        maxamp=-1.;
      }
    }
    FLUSH_LIST(list0,c0,gc,gc);
    RestoreWinAll();
  }
  */

  //  ResetCursor(topLevel);
}


/*
static void Keydown(w, event, params, num_params)
Widget w;
XEvent *event;
String *params;
Cardinal *num_params;
{
  KeySym keysym;
  char key_string[1];
  int key_string_len, i;

  key_string_len=XLookupString((XKeyEvent *) event, key_string,
    sizeof key_string, &keysym, (XComposeStatus *) NULL);
  if (keysym==XK_p) Playlast();
  if ((keysym==XK_plus) && (zoom==0)) { zoom=1; RedrawWin(); }
  if ((keysym==XK_minus) && (zoom)) { zoom=0; RedrawWin(); }
  if ((keysym==XK_less) && (leftkc>0) && (zoom)) { leftkc--; RedrawWin(); }
  if ((keysym==XK_greater) && (leftkc<R/2000) && (zoom)) { leftkc++; RedrawWin(); }
}
*/

/*
void setcolors(void)
{
  XSetForeground(theDisplay, theGCblack, black.pixel);
  XSetForeground(theDisplay, showGCblack, black.pixel);
  XSetForeground(theDisplay, theGCwhite, white.pixel);
  XSetForeground(theDisplay, showGCwhite, white.pixel);
  XSetForeground(theDisplay, theGCblue, blue.pixel);
  XSetForeground(theDisplay, showGCblue, blue.pixel);
}
*/


static gint expose_event( GtkWidget      *widget,
                          GdkEventExpose *event )
{
  RestoreWin(event->area.x,event->area.y,event->area.width,event->area.height);
  return FALSE;
}


void GUI_init(GtkWidget *dasdrawing_area,GtkWidget *dasprogressbar){
  GdkColormap *cmap;

  drawing_area=dasdrawing_area;
  progressbar=dasprogressbar;

  pixmap = gdk_pixmap_new(drawing_area->window,
			  drawing_area->allocation.width,
			  drawing_area->allocation.height,
			  -1);
  gdk_draw_rectangle (pixmap,
		      drawing_area->style->white_gc,
		      TRUE,
		      0, 0,
		      drawing_area->allocation.width,
		      drawing_area->allocation.height);

  blueGC=gdk_gc_new(drawing_area->window);
  cmap = gdk_colormap_get_system();
  bluecolor.red=0;
  bluecolor.green=0;
  bluecolor.blue=0xffff;

  if (!gdk_color_alloc(cmap, &bluecolor)) {
    g_error("couldn't allocate color");
  }

  gdk_gc_set_foreground(blueGC,&bluecolor);

  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc) expose_event, NULL);


  drawscale();
  RestoreWinAll();

}
