
#include "mammut.h"

/* Default must be set because button is not made with glade. */

bool synthandsave_normalize_gain=false;



extern struct LoadStruct loadstruct;


/* Following function copied from Ceres. */

void SaveWaveConsumer(
		      void *outfile,
		      float **samples,
		      int num_samples
		      )
{
  int i,ch;

  if((loadstruct.sfinfo.format&0xff)==0x2){

    if (loadstruct.sfinfo.pcmbitwidth==32) {
      float framebuff[num_samples*samps_per_frame];
      for (i=0; i<num_samples; i++) {
	for (ch=0; ch<samps_per_frame; ch++)
	  *(framebuff+i*samps_per_frame+ch)=(float)(samples[ch][i]);
      }
      sf_writef_float(outfile,framebuff,num_samples);

    }else{
      double framebuff[num_samples*samps_per_frame];
      for (i=0; i<num_samples; i++) {
	for (ch=0; ch<samps_per_frame; ch++)
	  *(framebuff+i*samps_per_frame+ch)=samples[ch][i];
      }
      sf_writef_double(outfile,framebuff,num_samples,0);
    }
    return;
  }

  if (loadstruct.sfinfo.pcmbitwidth==16) {
    int16_t framebuff[num_samples*samps_per_frame];
    for (i=0; i<num_samples; i++) {
      for (ch=0; ch<samps_per_frame; ch++)
	*(framebuff+i*samps_per_frame+ch)=(short)(samples[ch][i]*32767.);
    }
    sf_writef_short(outfile,framebuff,num_samples);
    return;
  }

  if (loadstruct.sfinfo.pcmbitwidth==24) {
    int32_t iframebuff[num_samples*samps_per_frame];
    for (i=0; i<num_samples; i++) {
      for (ch=0; ch<samps_per_frame; ch++)
	*(iframebuff+i*samps_per_frame+ch)=(int)(samples[ch][i]*8388608.);
    }
    sf_writef_int(outfile,iframebuff,num_samples);
    return;
  }

  if (loadstruct.sfinfo.pcmbitwidth==32){
    int32_t iframebuff[num_samples*samps_per_frame];
    for (i=0; i<num_samples; i++) {
      for (ch=0; ch<samps_per_frame; ch++)
	*(iframebuff+i*samps_per_frame+ch)=(int)(samples[ch][i]*2147483647.0);
    }
    sf_writef_int(outfile,iframebuff,num_samples);
    return;
  }
}



bool normalize(void)
{
  int i, ch;
  float max, samp;
  float *l;

  max=-1e+10;
  for (ch=0; ch<samps_per_frame; ch++) {
    l=lyd+ch*N;
    for (i=0; i<N; i++) {
      samp=*(l+i);
      if (samp>max) max=samp;
      if (-samp>max) max=-samp;
    }
  }
  if (synthandsave_normalize_gain) {
    max=0.9/max;
    for (ch=0; ch<samps_per_frame; ch++) {
      l=lyd+ch*N;
      for (i=0; i<N; i++) *(l+i)*=max;
    }
  } else if (max>0.99) {
    fprintf(stderr,"Can\'t save properly. Try to check the \"Normalize gain\" box.\n");
    return false;
 }
  return true;
}




void writesound(
		void (*WaveConsumer)(
				void *pointer,
				float **samples,
				int num_samples
				),
		void *pointer
		)
{
  int i, ch;
  float *l=lyd;

  float **ly;

  if (normalize()==false) return;

  ly=malloc(sizeof(float*)*samps_per_frame);


  for(i=0;i<N;i+=1024){
    for(ch=0;ch<samps_per_frame;ch++){
      ly[ch]=l+i+(ch*N);
    }
    (*WaveConsumer)(pointer,ly,min(N-i,1024));
  }

  free(ly);
}

void SaveOk(char *filename)
{

  long i,ch;

  /*
  out_AFsetup=afNewFileSetup();
  afInitChannels(out_AFsetup, AF_DEFAULT_TRACK, samps_per_frame);
  afInitRate(out_AFsetup, AF_DEFAULT_TRACK, R);
  afInitCompression(out_AFsetup, AF_DEFAULT_TRACK, compression);
  afInitFileFormat(out_AFsetup, filefmt);
  afInitSampleFormat(out_AFsetup, AF_DEFAULT_TRACK, samp_type, bits_per_samp);

  outfile=afOpenFile(filename, "wb", out_AFsetup);
  */

  outfile=sf_open_write(filename,&loadstruct.sfinfo);

  if (outfile==NULL) {
    fprintf(stderr,"Can\'t open file.\n");
    return;
  }
  for (i=0; i<samps_per_frame*N; i++) lyd2[i]=lyd[i];

  for (ch=0; ch<samps_per_frame; ch++) {
    rfft(lyd+ch*N,  N/2,  INVERSE);
  }

  writesound(SaveWaveConsumer,outfile);
  
  //  afCloseFile(outfile);
  sf_close(outfile);

  for (i=0; i<samps_per_frame*N; i++) lyd[i]=lyd2[i];
  strcpy(playfile, filename);
}
